use strict;
use warnings;

my ($in_preds_map, $in_preds_to_t_sw, $out_preds_to_t_sw_map) = @ARGV;

# add the mapping info status from here:
# T	C	S	evalue	Type	annotFeature	propOverlap

# to the target coverage:
# metaeuk_TCS	is_rep	seqid_to_T	qcov	tcov	sw_bits	sw_evalue	metaeuk_bits	metaeuk_evalue	metaeuk_num_exons

my %pred_to_stat;
open (my $in_map, "<", $in_preds_map) or die "could not open $in_preds_map for reading\n";
my $map_line = <$in_map>; # header
$map_line = <$in_map>;
while (defined $map_line) {
	chomp ($map_line);
	my ($target, $contig, $strand, @rest_of_line) = split (/\t/, $map_line);
	my $tcs_str = join ("\|", ($target, $contig, $strand));
	my $rest = join("\t", @rest_of_line);
	$pred_to_stat{$tcs_str} = $rest;
	$map_line = <$in_map>;
}
close ($in_map);


open (my $out, ">", $out_preds_to_t_sw_map) or die "could not open $out_preds_to_t_sw_map for writing\n";
open (my $in, "<", $in_preds_to_t_sw) or die "could not open $in_preds_to_t_sw for reading\n";
my $header = <$in>; # header
chomp ($header);
$header = join("\t", ($header,"metaeuk_eval","map_type","annotFeat","propOverlap"));
print $out "$header\n";
my $line = <$in>;
while (defined $line) {
	chomp ($line);
	my ($tcs_str) = split (/\t/, $line);
	my $new_line = "";
	if (exists $pred_to_stat{$tcs_str}) {
		$new_line = "$line\t$pred_to_stat{$tcs_str}";
	} else {
		die "could not find $tcs_str in map file\n";
	}
	print $out "$new_line\n";
	$line = <$in>;
}
close ($in);
close ($out);