use strict;
use warnings;

#@ARGV = ('C:\Users\eli\Dropbox\Postdoc\MetaEuk\metagenomics\OG5_127924\RAxML_bestTree.OG5_127924_OrthoMCL_MMETSP_metaeuk_arc_bac_pols_all_domains_lineage.nwc','C:\Users\eli\Dropbox\Postdoc\MetaEuk\universal_phylo_marker\MMETSP\keeling_colors.txt');
#@ARGV = ('C:\Users\a-elevyka\Dropbox\Postdoc\MetaEuk\metagenomics\OG5_127924\RAxML_bestTree_with_boot.OG5_127924_OrthoMCL_MMETSP_metaeuk_arc_bac_pols_all_domains_no_dups_lineage.nwc','C:\Users\a-elevyka\Dropbox\Postdoc\MetaEuk\universal_phylo_marker\MMETSP\keeling_colors.txt');
#@ARGV = ('C:\Users\a-elevyka\Dropbox\Postdoc\MetaEuk\metagenomics\OG5_127924\RAxML_bestTree_with_boot.OG5_127924_OrthoMCL_MMETSP_metaeuk_arc_bac_pols_all_domains_lineage.nwc','C:\Users\a-elevyka\Dropbox\Postdoc\MetaEuk\universal_phylo_marker\MMETSP\keeling_colors.txt');

my ($in_tree_nwc, $in_keeling_colors) = @ARGV;

#$out_iTOL_leaf_cols, $out_iTOL_legend

# so many output files ...
my $out_iTOL_leaf_cols = $in_tree_nwc;
$out_iTOL_leaf_cols =~ s/.nwc/_leaves_annot.txt/;

my $out_iTOL_legend = $in_tree_nwc;
$out_iTOL_legend =~ s/.nwc/_legend_annot.txt/;

my $out_tree_short = $in_tree_nwc;
$out_tree_short =~ s/.nwc/_short_labels.nwc/;

my $out_iTOL_leaf_cols_short = $out_tree_short;
$out_iTOL_leaf_cols_short =~ s/.nwc/_leaves_annot.txt/;

my $out_iTOL_legend_short = $out_tree_short;
$out_iTOL_legend_short =~ s/.nwc/_legend_annot.txt/;


open (my $in, "<", $in_tree_nwc) or die "could not open $in_tree_nwc for reading\n";
my $tree_str = <$in>;
chomp ($tree_str);
close ($in);

my $tree_short_str = $tree_str;

my @all_tree_labels = $tree_str =~ /[\(,]([^\(\),:]+)[\),:]/g;
my $num_lables = scalar(@all_tree_labels);
#print "found $num_lables in tree\n";

open (my $in_cols, "<", $in_keeling_colors) or die "could not open $in_keeling_colors for reading\n";
my %groups_to_group_name_and_color;
my $col_line = <$in_cols>;
while (defined $col_line)
{
	chomp ($col_line);
	if ($col_line =~ m/(\S+)\s*\~\s*(\S+)\s*[a-zA-Z_]*\s*\~\s*(\d+)\s*\~\s*(-?\d+)/)
	{
		my $group_name = $1;
		my $group_col = $2;
		my $are_sub_groups = $3;
		my $group_order = $4;
		
		$groups_to_group_name_and_color{$group_name}{group_name} = $group_name;
		$groups_to_group_name_and_color{$group_name}{group_col} = $group_col;
		$groups_to_group_name_and_color{$group_name}{regex} = prepare_for_regex($group_name);
		$groups_to_group_name_and_color{$group_name}{are_subgroups} = $are_sub_groups;
		$groups_to_group_name_and_color{$group_name}{order} = $group_order;
		#print "$group_name\t$groups_to_group_name_and_color{$group_name}{regex}\t$group_col\n";
		$col_line = <$in_cols>;
		while ((defined $col_line) and ($col_line !~ m/\~/))
		{
			chomp ($col_line);
			$col_line =~ s/\s*$//;
			my $group_member = $col_line;
			if ($group_member ne "")
			{
				$groups_to_group_name_and_color{$group_member}{group_name} = $group_name;
				$groups_to_group_name_and_color{$group_member}{group_col} = $group_col;
				$groups_to_group_name_and_color{$group_member}{regex} = prepare_for_regex($group_member);
				$groups_to_group_name_and_color{$group_member}{are_subgroups} = 0;
				$groups_to_group_name_and_color{$group_member}{order} = $group_order;
				#print "$group_member\t$groups_to_group_name_and_color{$group_member}{regex}\t$group_col\n";
			}
			$col_line = <$in_cols>;
		}
	}
}
close ($in_cols);
#print "finished loading colors\n";

my %tree_label_to_color;
my %leaf_label_to_line;
foreach my $tree_label (@all_tree_labels)
{
	my $label_id = "";
	if ($tree_label =~ m/^([^\|]+)(\|([^\|]+))?/)
	{
		$label_id = $1;
		my $rna_pol_id = $3;
		$label_id =~ s/Plastid\_|Mitochondria\_|metaeuk\_|Bacteria\_|Archaea\_//;
		
		if ($label_id =~ m/RNA_pol/)
		{
			$label_id = $rna_pol_id;
		}
	}
	my $found_group = "no";
	my $tree_label_lc = lc($tree_label);
	foreach my $group_member (keys %groups_to_group_name_and_color)
	{
		my $member_regex = $groups_to_group_name_and_color{$group_member}{regex};
		my $member_col = $groups_to_group_name_and_color{$group_member}{group_col};
		my $member_group_name = $groups_to_group_name_and_color{$group_member}{group_name};
		my $are_subgroups = $groups_to_group_name_and_color{$group_member}{are_subgroups};
		my $order = $groups_to_group_name_and_color{$group_member}{order};
		
		if ($tree_label_lc =~ m/\|$member_regex|^$member_regex/)
		{
			my $short_label = $label_id . '|' . $member_group_name;
			$short_label = pad_with_X($short_label);
			$leaf_label_to_line{$tree_label}{short_label} = $short_label;
			$leaf_label_to_line{$tree_label}{leaf_line} = "$tree_label,label,$member_col,normal,10";
			$leaf_label_to_line{$tree_label}{leaf_line_short} = "$short_label,label,$member_col,normal,10";
			if ($member_group_name eq "deeply_rooted")
			{
				$tree_label_to_color{$group_member}{color} = $member_col;
				$tree_label_to_color{$group_member}{order} = $order;
				$short_label = $label_id . '|' . $group_member;
				$short_label = pad_with_X($short_label);
				$leaf_label_to_line{$tree_label}{short_label} = $short_label;
				$leaf_label_to_line{$tree_label}{leaf_line_short} = "$short_label,label,$member_col,normal,10";
			}
			else
			{
				$tree_label_to_color{$member_group_name}{color} = $member_col;
				$tree_label_to_color{$member_group_name}{order} = $order;
			}
			$found_group = "yes";
			if ($are_subgroups == 0)
			{
				last;
			}
		}
	}
	if ($found_group eq "no")
	{
		print "could not match '$tree_label_lc'\n";
		my $short_label = pad_with_X($tree_label);
		$leaf_label_to_line{$tree_label}{short_label} = $short_label;
		$leaf_label_to_line{$tree_label}{leaf_line} = "$tree_label,label,#ffffff,normal,10";
		$leaf_label_to_line{$tree_label}{leaf_line_short} = "$short_label,label,#ffffff,normal,10";
	}
}

my $legend_line0 = "LEGEND_SHAPES";
my $legend_line1 = "LEGEND_COLORS";
my $legend_line2 = "LEGEND_LABELS";
foreach my $leg_label (sort {$tree_label_to_color{$a}->{order} <=> $tree_label_to_color{$b}->{order}} (keys %tree_label_to_color))
{
	if ($tree_label_to_color{$leg_label}{order} == -1)
	{
		next;
	}
	my $col = $tree_label_to_color{$leg_label}{color};
	$legend_line0 .= ",1";
	$legend_line1 .= ",$col";
	$legend_line2 .= ",$leg_label";
}

#### print to output ####
open (my $out_leg, ">", $out_iTOL_legend) or die "could not open $out_iTOL_legend for writing\n";
print $out_leg "DATASET_STYLE\nSEPARATOR COMMA\nDATASET_LABEL,legend\nCOLOR,#ffff00\nLEGEND_TITLE,Taxonomic groups\n$legend_line0\n$legend_line1\n$legend_line2\nDATA\n";
open (my $out_col_ann, ">", $out_iTOL_leaf_cols) or die "could not open $out_iTOL_leaf_cols for writing\n";
print $out_col_ann "TREE_COLORS\nSEPARATOR COMMA\nDATA\n";

open (my $out_leg_short, ">", $out_iTOL_legend_short) or die "could not open $out_iTOL_legend_short for writing\n";
print $out_leg_short "DATASET_STYLE\nSEPARATOR COMMA\nDATASET_LABEL,legend\nCOLOR,#ffff00\nLEGEND_TITLE,Taxonomic groups\n$legend_line0\n$legend_line1\n$legend_line2\nDATA\n";
open (my $out_col_ann_short, ">", $out_iTOL_leaf_cols_short) or die "could not open $out_iTOL_leaf_cols_short for writing\n";
print $out_col_ann_short "TREE_COLORS\nSEPARATOR COMMA\nDATA\n";

foreach my $tree_label (keys %leaf_label_to_line)
{
	my $short_label = $leaf_label_to_line{$tree_label}{short_label};
	my $tree_label_no_esc = $tree_label;
	$tree_label_no_esc =~ s/\|/\\\|/g;
	$tree_label_no_esc =~ s/\./\\\./g;
	$tree_short_str =~ s/$tree_label_no_esc/$short_label/;
	
	my $to_print_leaf = $leaf_label_to_line{$tree_label}{leaf_line};
	print $out_col_ann "$to_print_leaf\n";
	
	my $to_print_leaf_short = $leaf_label_to_line{$tree_label}{leaf_line_short};
	print $out_col_ann_short "$to_print_leaf_short\n";
}
close ($out_col_ann);
close ($out_leg);

close ($out_col_ann_short);
close ($out_leg_short);

open (my $out_tree, ">", $out_tree_short) or die "could not open $out_tree_short for writing\n";
print $out_tree "$tree_short_str\n";
close ($out_tree);


sub prepare_for_regex
{
	my ($in_str) = @_;
	my $in_str_lc = lc($in_str);
	if ($in_str_lc eq "archaea")
	{
		return ($in_str_lc);
	}
	if ($in_str_lc =~ m/(tes|les|ids)$/)
	{
		$in_str_lc =~ s/(tes|les|ids)$//;
	}
	elsif ($in_str_lc =~ m/s$/)
	{
		$in_str_lc =~ s/s$//;
	}
	$in_str_lc =~ s/([aeoiu]+)$//;
	return ($in_str_lc);
}


sub pad_with_X
{
	my ($str) = @_;
	
	my $required_length = 40;
	my $str_len = length($str);
	if ($str_len > $required_length)
	{
		die "too long to pad: '$str'\n";
	}
	
	my $diff = $required_length - $str_len;
	if ($diff <= 1)
	{
		return $str;
	}
	
	my $tail_to_add = "\|" . ("X" x ($required_length - 1));
	return ($str . $tail_to_add);
}
